﻿# -*- coding:Utf-8 -*-
#//----------------------------------------------------------//
#//  Script name : Royalglory SX.Mod                         //
#//  Script version : 1.0                                    //
#//  Script Auteur : Sioux (equipe SpiritOfGame-S.O.G)       //
#//----------------------------------------------------------//
#//  Fichier : rgsxm_weaponcolor.py                          //
#//  Auteur : L'In20Cible (Pour Royalglory)                  //  
#//----------------------------------------------------------//

import es

PLAYERS = dict()

def load():
   es.addons.registerTickListener(TickListenerCallBack)
   
def es_map_start(event_var):
   PLAYERS.clear()
   
def TickListenerCallBack():
   for userid in es.getUseridList():
      if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
         weapon = es.getindexfromhandle(es.getplayerprop(userid, "CBasePlayer.baseclass.m_hActiveWeapon"))
         if weapon:
            rendercolor = es.entitygetvalue(es.getindexfromhandle(es.getplayerhandle(userid)), "rendercolor")
            if not PLAYERS.has_key(userid) or weapon != PLAYERS[userid]["weapon"] or rendercolor != PLAYERS[userid]["rendercolor"]:
               PLAYERS[userid] = {"weapon": weapon,
                  "rendercolor": rendercolor}
               rendermode = int(es.entitygetvalue(weapon, "rendermode"))
               if not rendermode & 1:
                  es.entitysetvalue(weapon, "rendermode",  rendermode | 1)
               es.entitysetvalue(weapon, "rendercolor", rendercolor)
               es.entitysetvalue(weapon, "renderamt", rendercolor.split()[3])
               
def player_disconnect(event_var):
   userid = int(event_var["userid"])
   if PLAYERS.has_key(userid):
      del PLAYERS[userid]
      
def unload():
   es.addons.unregisterTickListener(TickListenerCallBack)