﻿# -*- coding:Utf-8 -*-
#//----------------------------------------------------------//
#//  Script name : Royalglory SX.Mod                         //
#//  Script version : 1.0                                    //
#//  Script Auteur : Sioux (equipe SpiritOfGame-S.O.G)       //
#//----------------------------------------------------------//
#//  Fichier : rgsxm_pushplayer.py                           //
#//  Auteur : L'In20Cible et DoCky (Pour Royalglory)         //
#//----------------------------------------------------------//

import es
import playerlib
import playerviewlib
import vecmath

players = {}

def unload():
    players.clear()

def pushUser(userid , force=1, direction="av"):    # "av" = Avant / "ar" = Arriere
    if direction == "ar" or direction == "av":
        if not players.has_key(userid): players[userid] = playerviewlib.PlayerView(userid)
        pushPlayer(userid, force, direction)

def pushPlayer(userid, force=3, direction="av"):
    if es.exists('userid', userid):
        player = playerlib.getPlayer(userid)
        if not player.isdead:
            if es.getplayerprop(userid, 'CCSPlayer.m_angEyeAngles[0]') >= -90:
                playerview = players[userid]
                playerview.parameters = player,force
                playerview.callback = pushFwd if direction == "av" else pushBack
                playerview.coord()

def pushFwd(playerview):
    player,force = playerview.parameters
    pointA, pointB = vecmath.Vector(player.getEyeLocation()), vecmath.Vector(playerview.coordlist)
    m_vecBaseVelocity = vecmath.Vector(es.createvectorfrompoints(pointA, pointB)) * int(force)
    push(playerview.userid,m_vecBaseVelocity)

def pushBack(playerview):
    player,force = playerview.parameters
    pointA, pointB = vecmath.Vector(playerview.coordlist), vecmath.Vector(player.getEyeLocation())
    m_vecBaseVelocity = vecmath.Vector(es.createvectorfrompoints(pointA, pointB)) * int(force)
    push(playerview.userid,m_vecBaseVelocity)

def push(userid,m_vecBaseVelocity):
    if es.getplayerprop(userid, 'CBasePlayer.localdata.m_hGroundEntity') != -1:
        m_vecBaseVelocity.z += 250
    m_flFallVelocity = es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_flFallVelocity')
    if m_flFallVelocity > 0:
        m_vecBaseVelocity.z += m_flFallVelocity
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', m_vecBaseVelocity)
